import string
import zulu

#
# PageNavigation
#
class groupmenu:
  "This class creates a menu based on templates"

  def __init__(self):
    pass

  def doit(self, objZulu, objTemplate, objProcessingState, sParameter):
    """Example: sParameter='Page:0'   # The menu will be created for the navigation 'Page'. :0 stands for 'selectParentEntries'"""

    try:
      (sNavigation, sSelectParentEntries) = string.split(sParameter, ':')
    except ValueError:
      objZulu.objLogger.error('Expected something like "<!--Zulu:Python:MODULE_NAME:CLASS_NAME:1-->" but got "<!--Zulu:Python:menu:%s-->".' % sParameter, objTemplate.strTemplateFilename)
      raise ZuluException()

    objNavigation = objZulu.get_navigation_by_name(sNavigation)
    strReturn = ''
    sPagePath = objProcessingState.getPath(sNavigation)
    iLevel = -1
    bLiStarted = False
    for objEntry in objNavigation.listEntries:
      while iLevel > objEntry.iLevel:
        strReturn += '</li></ul>'
        iLevel -= 1
      if iLevel == objEntry.iLevel:
        strReturn += '</li><li>'
      if iLevel == -1:
        iLevel = 0
      while iLevel < objEntry.iLevel:
        strReturn += '<ul><li>'
        iLevel += 1

      sCurrentPath = objEntry.strPath
      if sCurrentPath==sPagePath or (sSelectParentEntries=='1' and string.find(sPagePath, sCurrentPath)==0):
        strTemplateName = ':Selected:%s:%d' % (objNavigation.strName, objEntry.iLevel)
      else:
        strTemplateName = ':Normal:%s:%d' % (objNavigation.strName, objEntry.iLevel)
      # Examples ':Normal:Page:0', ':Selected:Page:0'
      try:
        strTemplate = objZulu.dictTemplates[strTemplateName]
        sTmp = objZulu.replace_tags(objProcessingState, strTemplate, [objEntry] + objProcessingState.listEntries)
        sTmp = sTmp.replace('<!--Hidden_Zulu:', '<!--Zulu:')
        strReturn += sTmp;
      except KeyError:
        objZulu.objLogger.warning('Template <!--Zulu:Template%s--> not found.' % strTemplateName, objTemplate.strTemplateFilename)

    return strReturn
